    var axisapi = {
        
        key: "",
        endpoint: "",
        return_value: "",
        last_endpoint: "",
        
        call: function( {returntype = "", endpoint = "", oncomplete = "", p1 = "", p2 = "", p3 = "", p4 = "", p5 = ""} = {} ) {
            
            // reset return value
            axisapi.return_value = "";
            
            // check for valid parameters
            if ( axisapi.key == "" ) { 
                console.log('API Key Missing'); 
                return;
            
            } else if ( axisapi.server == "" ) { 
                console.log('API Endpoint Missing'); 
                return; 
            
            } else if ( endpoint == "" || endpoint === undefined ) { 
                console.log('API Endpoint Missing'); 
                return; 
            
            }

            var command = endpoint.replace( "/", "__" );
            
            $.post({
                url: axisapi.server + "lms/api.php",
                data: { auth: axisapi.key, command: command, p1: p1, p2: p2, p3: p3, p4: p4, p5: p5 },
                success: function(data) {
                    axisapi.last_endpoint = command + "~" + p1 + "~" + p2 + "~" + p3 + "~" + p4 + "~" + p5;
                    var result = new XMLSerializer().serializeToString( data );
                    var parser = new DOMParser();  
                    axisapi.return_value = parser.parseFromString( result, 'text/xml' );
                    if ( returntype == 'json' ) {
                        axisapi.return_value = axisapi.xml2json( axisapi.return_value );
                    }
                    oncomplete();
                }
            });
            
        },
        
        get_tag_data: function( tagname, xml_string ) {
            
            // Usage example: var x = axisapi.get_tag_data( "color", the_string );
            if ( xml_string.includes(tagname) ) {
                var start = xml_string.indexOf( tagname ) + tagname.length + 1,
                    end = xml_string.indexOf( "</" + tagname + ">" ),
                    num = end - start,
                    value = xml_string.substr( start, num );
                return value;
                
            } else {
                return "";
                
            }
        },
        
        xml2json: function( xml ) {
            var obj = {};

            if ( xml.nodeType == 1 ) { // element
                // attributes
                if ( xml.attributes.length > 0 ) {
                    obj["@attributes"] = {};
                    for (var j = 0; j < xml.attributes.length; j++) {
                        var attribute = xml.attributes.item(j);
                        obj["@attributes"][attribute.nodeName] = attribute.nodeValue;
                    }
                }

            } else if ( xml.nodeType == 4 ) {
            	// cdata
                obj = xml.nodeValue;

            }

            // children nodes
            if ( xml.hasChildNodes() ) {

                for( var i = 0; i < xml.childNodes.length; i++ ) {
                    var item = xml.childNodes.item( i );
                    var nodeName = item.nodeName;
                    
                        if ( typeof(obj[nodeName]) == "undefined" ) {
                            obj[nodeName] = axisapi.xml2json( item );

                        } else {
                            if ( typeof(obj[nodeName].length) == "undefined" ) {
                                var old = obj[nodeName];
                                obj[nodeName] = [];
                                obj[nodeName].push( old );
                            }

                            if ( typeof(obj[nodeName]) === 'object' ) {
                                obj[nodeName].push( axisapi.xml2json(item) );
                            }

                        }
                    
                }

            }

            return obj;
        }
        
    };